#include <netinet/in.h>
#include <netdb.h>

/* Diese Funktion erzeugt einen Socket und verbindet diesen mit dem
   Port <port> welcher von dem Server <host>

  host:         Server zu dem eine Verbindung aufgebaut werden soll
  port:         Port des Servers
  return Value: Der FileDescriptor des Sockets
*/
int Socket(host, port)
  char *host;
  int port;
{
  int sock;
  unsigned long inaddr;
  struct sockaddr_in ad;
  struct hostent *hp;
  
  // Variablen Lschen/mit 0en vollschreiben
  memset(&ad, 0, sizeof(ad));
  // Sockettyp-festlegen
  ad.sin_family = AF_INET;
  // Adresse der Servers besorgen
  inaddr = inet_addr(host);
  if (inaddr != INADDR_NONE) {
    memcpy(&ad.sin_addr, &inaddr, sizeof(inaddr));
  } else {
    hp = gethostbyname(host);
    if (hp == NULL) {
      perror("gethostbyname()");
      return -1;
    }
    memcpy(&ad.sin_addr, hp->h_addr, hp->h_length);
  }
  ad.sin_port = htons(port);
  // Socket erzeugen
  sock = socket(AF_INET, SOCK_STREAM, 0);
  if (sock < 0) {
    perror("socket()");
    return -1;
  }
  // Socket mit Server verbinden
  if (connect(sock, (struct sockaddr *) &ad, sizeof(ad)) < 0) {
    perror("connect()");
    return -1;
  }
  // Socket FD als Rckgabewert
  return sock;
}
