/*
    Dies ist meine zentrale Lib.

    Diese Function ermittelnt die Lnge einer Datei oder eines
    Block-Device, und gibt den Wert zurck. ACHTUNG: Bist ca. 2.1GByte

    Copyright (C) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
              hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/

*/


#include "hofmeier.h"
#include <stdio.h>
#include <sys/stat.h>
#include <fcntl.h>


static int valid_offset(int fd, int offset)
{
  char ch;

  if (lseek(fd, offset, 0) < 0) {
    return false;
  }
  if (read (fd, &ch, 1) < 1) {
    return false;
  }
  return true;
}


long filelen(s)
  char *s;
{
  struct stat buf;
  int fd;
  FILE *f;
  
  if ((f = fopen(s, "r")) == NULL) {
    return -1;
  } else {
    fd = fileno(f);
    fstat(fd, &buf);
    /* Block-Device-Prfen */
    if (buf.st_size == 0) {
      unsigned long high, low;

      if (fd == 0) {
	return -1;
      }
      low = 0;
      for (high = 1; valid_offset(fd, high); high *= 2) {
	low = high;
      }
      while(low < high - 1) {
	const int mid = (low + high) / 2;
	if (valid_offset(fd, mid)) {
	  low = mid;
	} else {
	  high = mid;
	}
      }
      valid_offset(fd, 0);
      close(fd);
      fclose(f);

      return (low == 0) ? 0 : low + 1;
    } else {
      close(fd);
      fclose(f);
      return buf.st_size;
    }
  }
}

