/*
    hofmeier.h

    Dies ist meine zentrale Lib.

    Diese Funktion besorgt ein TTY-Devices, gibt den FD zu diesem
    zurck und fllt die Parameter, ca. char[20], mit dessen Namen
    auf. (TTY, PTY)

    Copyright (C) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
              hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/


*/


#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/time.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <signal.h>
#include "hofmeier.h"


/* Diese Funktion besorgt ein PseudoTTY vom System. Sie
   gibt einen FileDiscriptor auf diesen zurck, oder -1
   wenn ein Fehler aufgetreten ist...

   Weiterhin fllt die Funktion die beiden Strings (tty,
   pty) aus. DIESE MSSEN EIN POINTER AUF EINE
   SPEICHERBEREICH VON ETWA 20BYTES SEIN!
*/
int blacky_gettty(tty, pty)
  char *tty, *pty;
{
  int fd;
  static char     pty_name[] = "/dev/pty??";
  static char     tty_name[] = "/dev/tty??";
  int             len = strlen(tty_name);
  char           *c1, *c2, s[200];
  
  char *ptydev = pty_name;
  char *ttydev = tty_name;
  
# define PTYCHAR1	"pqrstuvwxyz"
# define PTYCHAR2	"0123456789abcdef"
  for (c1 = PTYCHAR1; *c1; c1++) {
    ptydev[len - 2] = ttydev[len - 2] = *c1;
    for (c2 = PTYCHAR2; *c2; c2++) {
      ptydev[len - 1] = ttydev[len - 1] = *c2;
      if ((fd = open(ptydev, O_RDWR)) >= 0) {
	if (access(ttydev, R_OK | W_OK) == 0) {
	  goto Found;
	}
	close(fd);
      }
    }
  }
  perror("can't open pseudo-tty");
  return -1;

  Found:
  //    fcntl(fd, F_SETFL, O_NDELAY);
  sprintf(s, "stty raw -echo < %s", ttydev);
  system(s);
  strcpy(tty, ttydev);
  strcpy(pty, ptydev);
  return fd;
}
