/*
    hofmeier.h

    Dies ist meine zentrale Lib.

    Hir das Headerfile.


    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
	      hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/



   Hofmeier standart UNIT

   Beim Compilen immen -lhofmeier anfgen!
*/

#ifndef HOFMEIER_H_
#define HOFMEIER_H_


#include <stdio.h>
#include <stdbool.h>

/* boolean */
#ifndef false
 #define false 0;
#endif

#ifndef true
 #define true 1;
#endif


/* Graphikzeichensatz des Terminals Aktiviren... */
#define BLACKY_cur_Graphik 1

#define MAXLI 80  /* Maximale Lnge Ver.*/
char HLINE, VLINE, ROECK, RABGE, RUECK, LOECK, LABGE, LUECK, NOMBG, OABGE, UABGE, KREUZ;

/* Fehler Aufgetreten ? */
int blacky_status_error;

/* Blacky 2000 */
#define FILEERK "bp"
#define FILEEND "<-"



/* Macht alle Zeichen in einem String gro. z.B.: "Andreas" ->
   "ANDREAS". char *Gross(char *result, char *a) */
extern char *Gross(char *, char *);

/* Ermittelt die Position eines Strings (suchstr) in einem String
   (str) und gibt Position dieses zurck. suchopt, wird nicht
   bercksichtigt.
   int strpos(char *str, char *suchstr, int suchopt) */
extern int strpos (char *, char *, int);

/* Diese Funktion soll beim Starten eines meiner Programme den
   "normalen" Text ausgeben... (License, etc.) */
extern blackyintro(char *);
extern allblackyintro(char *);

/* Schreibt einen String in die Datei, wobei DOS-LineFeed verwendet
   wird */
extern doswrite(FILE *, char *);
/* Liet einen String aus der Datei, wobei das DOS-Linefeed entfernt
   wird, wenn es vorhanden ist */
extern int dosread(FILE *, char *, int);

/* Diese Function ermittelnt die Lnge einer Datei oder eines
   Block-Device, und gibt den Wert zurck. ACHTUNG: Bist ca. 2.1GByte */
extern long filelen(char *);

/* Liet einen String in PASCAL-Format aus einer Datei. Also zuerst
   ein Byte welches aussagt wie lang der String ist und dann der
   String. KEINE NULL TERMINIERUNG! Gibt einen normalen String zurck. */
extern char readastring(FILE *, char *);
/* Schreibt einen String in PASCAL-Format in eine Datei. Also zuerst
   ein Byte welches aussagt wie lang der String ist und dann der
   String. KEINE NULL TERMINIERUNG! */
extern writeastring(FILE *, char *);

/* Convertiert einen Linux in einen DOS-String. */
extern char *todos(char *);

/* Diese Funktion soll eine Datei verschieben um ein Sicherung beim
   Speichern zu gewhrleisten. (Nach *.BSK.) */
extern void bsk(char *);

/* Diese Funktion kombiniert fsync und fflush. Schreibt also alle in
   f gepufferten Daten auf die Platte. */
extern ffsync(FILE *);

/* Fgt ein String an einer gekennzeichneten Stellen ein einen String
   ein. */
extern setzeein(char *);

/* Get the week of year form a UNIX-time */
extern int getweek(unsigned long);

/* ***** Make-Ascii-Tab ***** */
/* Wandelt ein Char in Unix-Zeichen um 
   Liest c und gibt einen char[3] mit dem Zeichen in st aus!
   uz(char *st, unsigned char c) */
extern uz(char *, unsigned char);
/* Berechnet das Bitmuster eines Bytes. Byte: xcode; Muster wird in st
   abgelegt makedc(char *st, unsigned char xcode) */
extern makedc(char *, unsigned char);
/* Gibt den Namen eines Zeichens zurck.
   Bekommt das Zeichen in c und Schreibt den Namen in
   st welcher ein char[] ist!
   getcharname(char *st, unsigned char c) */
extern getcharname(char *, unsigned char);

/* Ermittelt die Lnge einer Diskette, mit hilfe von filelen und gibt
   das Ergebnis aus und zurck. */
extern long getdisksize(char *, char, char);

/* Gibt die Sekunden l als String "StundenMinuten'Sekunden" zurck */
extern char *printz(unsigned long);

/* Diese Funktion ndert den Titel eines xTerms. Parameter:
   Programmname, Dateiname. */
extern void blacky_xterm_set_titel(char *, char *);

/* Diese Funktion besorgt ein TTY-Devices, gibt den FD zu diesem
   zurck und fllt die Parameter, ca. char[20], mit dessen Namen
   auf. (TTY, PTY) */
extern int  blacky_gettty(char *, char *);

/* ***** Blacky Socket Funktionen ***** */
/* Demoprogramm fr Socket(), Bind(), SockRecvString(),
   SockSendString() und SockMD5Auth(): smd5auth */
/* ffne lokalen Socket, und gib dessen FD zurck.
   socket_fd = Bind(Port, MaxInQueue); */
extern int Bind(int, int);
/* Ferbinde dich mit dem "entfernten Socket" und gib den Verbindungs
   FD zurck.  socket_fd = Socket(host, port); */
extern int Socket(char *, int);
/* Sende fprint-Formatierten String in Socket, 
   gesendeteZeichen = SockPrintf(socket, format, va_alist) */
extern int SockPrintf();
/* *** spezielles Protukoll gegen Timing-Probleme *** */
/* Sende String in Socket, (strlen(string) <= 255) !
   stringlnge = SockSendString(socket_fd, string); */
extern int SockSendString(int, char *);
/* Empfange String von Socket, (strlen(string) <= 255) !
   stringlnge = SockRecvString(socket_fd, string); */
extern int SockRecvString(int, char *);
/* Sende Datei in Socket, Maximale Dateigre: long int
   filesize = SockSendFile(socket_fd, filename); */
extern long SockSendFile(int, char *);
/* Empfange Datei aus Socket, Maximale Dateigre: long int
   filesize = SockRecvFile(socket_fd, filename); */
extern long SockRecvFile(int, char *);
/* berprfe, ob gegenber der ist, fr den er sich ausgiebt.
   if (SockMD5Auth(socket, authstring) == 1) {
     ... OK  */
extern int SockMD5Auth(int, char *);

/* ***** Console-Grapfik (curses) ***** */
/* Diese Funktion bereitet ncurses vor... */
extern void init_cur_graph();
/* Erzeugt ein Linie und fllt Sie. (curses) */
extern makeline(unsigned char, unsigned char, unsigned char, int, int);
/* Fuellt ein Zeichen auf dem NCurses-Screen mit Alternativem Zeichensatz */
extern makepoint(unsigned char, int, int);
/* Ruft move (curses) auf. Bewegt also den Cursor. */
extern gotoxy(int, int);
/* Lesen eines Strings von der Eingabe mit einfacher Editing-Funktion (curses) */
extern void editstr(char *, int, int, int);

/*
  GoToXY(50, 5); (Bei 1 beginnend)
   X = von Rechtz
   Y = von Links

Alias to:

  move(o, l) :
   Bei NULL beginnend !!!
   o = von oben;
   l = von links;
*/



#endif
