/*
    Dies ist meine zentrale Lib.

    Diese Funktion bereitet ncurses vor...

    Copyright (C) Andreas Hofmeier

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


    Name:     Andreas Hofmeier

    Adresse:  Stralsunder Strae 20
              28239 Bremen
              Germany

    Telefon:  +49-421-613793

    eMail:    An-H@An-H.de
              hofmeier@inbremen.de
              an-h@gmx.de

    Homepage: http://www.An-H.de/
              hofmeier.home.pages.de
              http://www.LGut.uni-bremen.de/anh/

*/

#include "hofmeier.h"
#include <curses.h>
#include <stdlib.h>

/* Angaben zum Zeichen */
void init_cur_graph()
{
#ifdef BLACKY_cur_Graphik
  char *s;

  /* Init curses ... */
  /* setupterm(); */           /* Init a goot Terminal */
  (void) initscr();              /* initialize the curses library */
  /*keypad(stdscr, FALSE);... nur Scheie! */
  keypad(stdscr, TRUE);
  (void) nonl();                 /* tell curses not to do NL->CR/NL on output */
  (void) cbreak();               /* take input chars one at a time, no wait for \n */
  (void) noecho();               /* don't echo input */
  /* Init curses colores ... */
  if (has_colors())
    {
      start_color();
      /*
       * Simple color assignment, often all we need.
       */
      init_pair(COLOR_BLACK, COLOR_BLACK, COLOR_BLACK);
      init_pair(COLOR_GREEN, COLOR_GREEN, COLOR_BLACK);
      init_pair(COLOR_RED, COLOR_RED, COLOR_BLACK);
      init_pair(COLOR_CYAN, COLOR_CYAN, COLOR_BLACK);
      init_pair(COLOR_WHITE, COLOR_WHITE, COLOR_BLACK);
      init_pair(COLOR_MAGENTA, COLOR_MAGENTA, COLOR_BLACK);
      init_pair(COLOR_BLUE, COLOR_BLUE, COLOR_BLACK);
      init_pair(COLOR_YELLOW, COLOR_YELLOW, COLOR_BLACK);
    }

  /* Rahmen ? */
  /* ASCII-Rahmen*/
  HLINE = '-'; /* Horizontale Linien */
  VLINE = '|'; /* Vertikale Linien   */
  ROECK = '+'; /* Obere rechte Ecke  */
  RABGE = '+'; /* T-Stck rschts     */
  RUECK = '+'; /* Untere rechte Ecke */
  LOECK = '+'; /* Obere linke Ecke   */
  LABGE = '+'; /* T-Stck linkss     */
  LUECK = '+'; /* Untere linkee Ecke */
  NOMBG = ' '; /* Freie Flchen      */

  OABGE = '+'; /* T-Stck - Oben     */
  UABGE = '+'; /* T-Stck - Unten    */
  KREUZ = '+'; /* Kreutzung          */

  /* Gehts noch besser? */
  s = getenv("TERM");
  if (strcmp(s, "xterm") == 0) { /* xterm */  
      HLINE = 'q'; /* Horizontale Linien */ /* ACHTUNG: Der aufbau von bps-pain ist davon abhngig! */
      VLINE = 'x'; /* Vertikale Linien   */
      ROECK = 'k'; /* Obere rechte Ecke  */
      RABGE = 't'; /* T-Stck rschts     */
      RUECK = 'j'; /* Untere rechte Ecke */
      LOECK = 'l'; /* Obere linke Ecke   */
      LABGE = 'u'; /* T-Stck linkss     */
      LUECK = 'm'; /* Untere linkee Ecke */
      NOMBG = ' '; /* Freie Flchen      */

      OABGE = 'w'; /* T-Stck - Oben     */
      UABGE = 'v'; /* T-Stck - Unten    */
      KREUZ = 'n'; /* Kreutzung          */
    }
  if (strcmp(s, "linux") == 0) { /* Linux-Console */  
      HLINE = 196; /* Horizontale Linien */ /* ACHTUNG: Der aufbau von bps-pain ist davon abhngig! */
      VLINE = 179; /* Vertikale Linien   */
      ROECK = 191; /* Obere rechte Ecke  */
      RABGE = 195; /* T-Stck rschts     */
      RUECK = 217; /* Untere rechte Ecke */
      LOECK = 218; /* Obere linke Ecke   */
      LABGE = 180; /* T-Stck linkss     */
      LUECK = 192; /* Untere linkee Ecke */
      NOMBG = ' '; /* Freie Flchen      */

      OABGE = 194; /* T-Stck - Oben     */
      UABGE = 193; /* T-Stck - Unten    */
      KREUZ = 198; /* Kreutzung          */
    }
#endif
#ifndef BLACKY_cur_Graphik
  HLINE = '-'; /* Horizontale Linien */
  VLINE = '|'; /* Vertikale Linien   */
  ROECK = '+'; /* Obere rechte Ecke  */
  RABGE = '+'; /* T-Stck rschts     */
  RUECK = '+'; /* Untere rechte Ecke */
  LOECK = '+'; /* Obere linke Ecke   */
  LABGE = '+'; /* T-Stck linkss     */
  LUECK = '+'; /* Untere linkee Ecke */
  NOMBG = ' '; /* Freie Flchen      */

  OABGE = '+'; /* T-Stck - Oben     */
  UABGE = '+'; /* T-Stck - Unten    */
  KREUZ = '+'; /* Kreutzung          */
#endif
}
